/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// NotificationSeverity the model 'NotificationSeverity'
type NotificationSeverity int32

// List of NotificationSeverity
const (
	SeverityInfo NotificationSeverity = 10
	SeverityWarning NotificationSeverity = 20
	SeverityCritical NotificationSeverity = 30
)

// All allowed values of NotificationSeverity enum
var AllowedNotificationSeverityEnumValues = []NotificationSeverity{
	10,
	20,
	30,
}

func (v *NotificationSeverity) UnmarshalJSON(src []byte) error {
	var value int32
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := NotificationSeverity(value)
	for _, existing := range AllowedNotificationSeverityEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid NotificationSeverity", value)
}

// NewNotificationSeverityFromValue returns a pointer to a valid NotificationSeverity
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewNotificationSeverityFromValue(v int32) (*NotificationSeverity, error) {
	ev := NotificationSeverity(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for NotificationSeverity: valid values are %v", v, AllowedNotificationSeverityEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v NotificationSeverity) IsValid() bool {
	for _, existing := range AllowedNotificationSeverityEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to NotificationSeverity value
func (v NotificationSeverity) Ptr() *NotificationSeverity {
	return &v
}

type NullableNotificationSeverity struct {
	value *NotificationSeverity
	isSet bool
}

func (v NullableNotificationSeverity) Get() *NotificationSeverity {
	return v.value
}

func (v *NullableNotificationSeverity) Set(val *NotificationSeverity) {
	v.value = val
	v.isSet = true
}

func (v NullableNotificationSeverity) IsSet() bool {
	return v.isSet
}

func (v *NullableNotificationSeverity) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNotificationSeverity(val *NotificationSeverity) *NullableNotificationSeverity {
	return &NullableNotificationSeverity{value: val, isSet: true}
}

func (v NullableNotificationSeverity) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNotificationSeverity) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

